{***********************************************************************
Unit ColorWheel.PAS v1.0 Build 0199
    (c) 1999 by Andreas Moser, AMoser@t-online.de

    Delphi version : Delphi 3

    ColorWheel.pas is part of the gfx_library collection

    You may use this sourcecode for your freewareproducts.
    You may modify this source-code for your own use.
    You may recompile this source-code for your own use.

    All functions, procedures and classes may NOT be used in commercial
    products without the permission of the author. For parts of this library
    which are not written by me, you have to ask for permission by their
    respective authors.

    Disclaimer of warranty: "This software is supplied as is. The author
    disclaims all warranties, expressed or implied, including, without
    limitation, the warranties of merchantability and of fitness for any
    purpose. The author assumes no liability for damages, direct or
    consequential, which may result from the use of this software."

    All brand and product names are marks or registered marks of their
    respective companies.

    Please report bugs to:
    Andreas Moser  AMoser@t-online.de

********************************************************************************}

unit ColorWheel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, gfx_basedef;

type
  TColorWheel = class(TPanel)
  private
    fShape1:TShape;
    fShape2:TShape;
    fColImage:TImage;
    dx,dy,sdX,sdY,sDegr,lCX,lCY,iX,iY:Integer;
    fActRed,fActGreen,fActBlue:Byte;
    procedure DrawRectangle;
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
    procedure Shape2MouseMove(Sender: TObject; Shift: TShiftState; X,
    Y: Integer);
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
  published
    property ActRed:Byte read fActred;
    property ActGreen:Byte read fActGreen;
    property ActBlue:Byte read fActBlue;
    { Published-Deklarationen }
  end;

procedure Register;

implementation

constructor TColorWheel.Create;
var i,s,v,x,y,x2,y2:Integer;
    RGBTrip:TRGBTriple;
    HSVTrip:THSVTriple;
begin
  inherited Create(AOwner);
  Width:=204;
  Height:=204;
  FColImage:=TImage.Create(self);
  FColImage.parent:=self;
  FColImage.Width:=Width-4;
  FColImage.Height:=Height-4;
  FColImage.Left:=2;
  FColImage.Top:=2;
  FColImage.Picture.Bitmap.PixelFormat:=pf24Bit;
  FColImage.Picture.Bitmap.Width:=Width;
  FColImage.picture.Bitmap.Height:=Height;
  FColImage.Picture.Bitmap.Canvas.Brush.Color:=clBtnFace;
  FColImage.Picture.Bitmap.Canvas.FillRect(Rect(0,0,Width,Height));
  FColImage.OnMouseUp:=ImageMouseUp;

  dx:=FColImage.Width div 2;
  dy:=FColImage.Height div 2;
  FColImage.Picture.Bitmap.Canvas.Pen.Color:=clBlack;
  FColImage.Picture.Bitmap.Canvas.Pen.Width :=3;
  FColImage.Picture.Bitmap.Canvas.MoveTo(Round(dx+(dx-25)*Sin(0*PI/180)),Round(dy+(dy-25)*Cos(0*PI/180)));
    HSVTrip.hsvSaturation:=255;
    HSVTrip.hsvValue:=255;
    for i:=1 to 360 do
    begin
      HSVTrip.hsvHue:=i;
      HSVtoRGB(HSVTrip,RGBTrip);
      FColImage.Picture.Bitmap.Canvas.Pen.Color:=RgbToColor(RGBTrip);
      x:=Round((dx-25)*Sin((i)*PI/180));
      y:=Round((dy-25)*Cos((i)*PI/180));
      x2:=Round((dx-5)*Sin((i)*PI/180));
      y2:=Round((dy-5)*Cos((i)*PI/180));
      FColImage.Picture.Bitmap.Canvas.MoveTo(dx+x,dy+y);
      FColImage.Picture.Bitmap.Canvas.LineTo(dx+x2,dy+y2);
    end;

    fShape1:=TShape.Create(Self);
    with fShape1 do begin
      Parent:=self;
      Brush.Style:=bsClear;
      Shape:=stCircle;
      Width:=6;
      Height:=6;
      BringToFront;
      Left:=FColImage.Left+FcolImage.Width div 2-fShape1.Width div 2;
      Top:=FColImage.Top+13-fShape1.Height div 2;
      sDx:=Left;
      sDy:=Top;
    end;
    sDegr:=0;
    DrawRectangle;
    fShape2:=TShape.Create(Self);
    with fShape2 do begin
      Parent:=self;
      Brush.Style:=bsClear;
      Shape:=stCircle;
      Width:=6;
      Height:=6;
      BringToFront;
      OnMouseMove:=Shape2MouseMove;
      Left:=lCX+1;
      Top:=lCY+1;
    end;
end;

destructor TColorWheel.Destroy;
begin
  inherited Destroy;
end;

procedure TColorWheel.DrawRectangle;
var i,Col:Integer;
    x3,x4,y1,y4:Integer;
    RGBTrip:TRGBTriple;
    Row:pRGBArray;
    HSV:THSVTriple;
begin
//  dx:=FColImage.Picture.Bitmap.Width div 2;
//  dy:=FColImage.Picture.Bitmap.Height div 2;
  lCX:=Round(dx+(dx-30)*Sin((315)*PI/180));
  y1:=Round(dy+(dy-30)*Cos((315)*PI/180));

//  x2:=Round(dx+(dx-30)*Sin((45)*PI/180));
//  y2:=Round(dy+(dy-30)*Cos((45)*PI/180));

  x3:=Round(dx+(dx-30)*Sin((135)*PI/180));
//  y3:=Round(dy+(dy-30)*Cos((135)*PI/180));

  x4:=Round(dx+(dx-30)*Sin((225)*PI/180));
  y4:=Round(dy+(dy-30)*Cos((225)*PI/180));
  lCY:=y4;

  iX:=(x3-x4);
  iY:=(y1-y4);
     Caption:=IntToStr(sDegr);
for i:=0 to iX {255} do
begin
  Row:=FColImage.Picture.Bitmap.ScanLine[i+x4];
  for Col:=0 to iY{255} do begin
       RgbTrip.rgbtRed:=TrimReal(0,255,(255-(i*(255/iX))+((i*Col*(255/iX))/ iX)));
       RgbTrip.rgbtBlue:=TrimReal(0,255,(255/iX)*Col);
       RgbTrip.rgbtGreen:=TrimReal(0,255,(255/iX)*Col);
     RGBtoHSV(RGBTrip,hsv);
     HSV.hsvHue:=sDegr;
     HSV.hsvHue:=LoopInt(0,359,HSV.hsvHue);
     HSVtoRGB(HSV,RGBTrip);
     Row[Col+y4].rgbtRed :=RGBTrip.rgbtRed;
     Row[Col+y4].rgbtBlue :=RGBTrip.rgbtBlue;
     Row[Col+y4].rgbtGreen :=RGBTrip.rgbtGreen;
end;
end;
  FColImage.Repaint;
  if Assigned(fShape2) then
  begin
    Row:=fColImage.Picture.Bitmap.Scanline[fShape2.Top];
    fActRed:=Row[fShape2.Left].rgbtRed;
    fActGreen:=Row[fShape2.Left].rgbtGreen;
    fActBlue:=Row[fShape2.Left].rgbtBlue;
  end;

end;


procedure TColorWheel.ImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var dx,dy,r,a,b:Integer;
    sinalpha,cosalpha:double;
    Row:pRGBArray;
    RGBT:TRGBTriple;
begin
   dx:=FcolImage.Width div 2;
   dy:=FcolImage.Height div 2;
   a:=Abs(X-dx);
   b:=Abs(y-dy);
 {  d:=MaxInt2(a,b);
   b:=MinInt2(a,b);
   a:=d;
  } r:=Round(sqrt((a*a)+(b*b)));
   sinalpha:=a/r;
   cosAlpha:=b/r;
   if (r>dx-25) and (r<dx-5) then  begin
      if (x>dx) and (y<dy) then
      begin
        fShape1.Left:=Round(dx+(dx-15)*(SinAlpha))+fShape1.Width div 2;
        fShape1.Top:=Round(dy-(dy-15)*(CosAlpha))+fShape1.Height div 2;
        sDegr:=180-Round(xArcSin(SinAlpha)/pi*180);
      end else
      if (x>dx) and (y>dy) then
      begin
        fShape1.Left:=Round(dx+(dx-15)*(SinAlpha))+fShape1.Width div 2;
        fShape1.Top:=Round(dy+(dy-15)*(CosAlpha))+fShape1.Height div 2;
        sDegr:=Round(xArcSin(SinAlpha)/pi*180);
      end else
      if (x<dx) and (y>dy) then
      begin
        fShape1.Left:=Round(dx-(dx-15)*(SinAlpha))+fShape1.Width div 2;
        fShape1.Top:=Round(dy+(dy-15)*(CosAlpha))+fShape1.Height div 2;
        sDegr:=360-Round(xArcSin(SinAlpha)/pi*180);
      end else
      if (x<dx) and (y<dy) then
      begin
        fShape1.Left:=Round(dx-(dx-15)*(SinAlpha))+fShape1.Width div 2;
        fShape1.Top:=Round(dy-(dy-15)*(CosAlpha))+fShape1.Height div 2;
        sDegr:=180+Round(xArcSin(SinAlpha)/pi*180);
      end;
      Row:=fColImage.Picture.Bitmap.Scanline[fShape1.Top];
      RGBT:=Row[fShape1.Left];
      RGBT.rgbtBlue:=255-RGBT.rgbtBlue;
      RGBT.rgbtGreen:=255-RGBT.rgbtGreen;
      RGBT.rgbtRed:=255-RGBT.rgbtRed;
      fShape1.Pen.Color:=RGBToColor(RGBT);

      DrawRectangle;
   end;
end;

procedure TColorWheel.Shape2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var Row:pRGBArray;
    RGBT:TRGBTriple;
begin
  if ssLeft in Shift then
  begin
    if x>0 then
    fShape2.Left:=fShape2.Left+2 else if x<0 then fShape2.Left:=fShape2.Left-2;
    if y>0 then
    fShape2.Top:=fShape2.Top+2 else if y<0 then fShape2.Top:=fShape2.Top-2;
    if fShape2.Top<dy-(iY div 2) then fShape2.Top:=dy-(iY div 2) else
    if fShape2.Top>dy+(iY div 2) then fShape2.Top:=dy+(iY div 2);
    if fShape2.Left<dX-(iX div 2) then fShape2.Left:=dX-(iX div 2) else
    if fShape2.Left>dX+(iX div 2) then fShape2.Left:=dX+(iX div 2);
    Row:=fColImage.Picture.Bitmap.Scanline[fShape2.Top];
    RGBT:=Row[fShape2.Left];
    fActRed:=RGBT.rgbtRed;
    fActGreen:=RGBT.rgbtGreen;
    fActBlue:=RGBT.rgbtBlue;
    RGBT.rgbtBlue:=255-RGBT.rgbtBlue;
    RGBT.rgbtGreen:=255-RGBT.rgbtGreen;
    RGBT.rgbtRed:=255-RGBT.rgbtRed;

    fShape2.Pen.Color:=RGBToColor(RGBT);
    Application.mainForm.Caption:=IntToStr(FactRed)+' '+IntToStr(FactGreen)+' '+IntToStr(FactBlue);
  end;

end;

procedure Register;
begin
  RegisterComponents('AM FX Pro', [TColorWheel]);
end;

end.
